!c Description:
!c   LU ʬˡ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-05-30    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_lusbs
  interface
     
     subroutine lusbs(A, B, order, scale_factor)
       real(8), intent(in)    :: A(:,:)
       real(8), intent(inout) :: B(:)
       real(8), intent(in)    :: scale_factor(:,:)
       integer(8), intent(in) :: order(:,:)
     end subroutine lusbs

  end interface
end module interface_lusbs




subroutine lusbs(A, B, order, scale_factor)
  real(8), intent(in)     :: A(:,:)
  real(8), intent(inout)  :: B(:)
  real(8), intent(in)     :: scale_factor(:,:)
  integer(8), intent(in)  :: order(:,:)
  integer(8)              :: n, i


  n = size(A, 1)
  !Υ
  B = B * scale_factor(:,1)
  !٥ȥν
  B = B(order(:,1))

  ! (Ly = b)
  l_sub: do i = 1, n
     B(i) = (B(i) - dot_product(B(1:i-1), A(i,1:i-1))) / A(i,i)
  end do l_sub

  ! (Ux = y)
  u_sub: do i = n-1, 1, -1
     B(i) = B(i) - dot_product(B(i+1:n), A(i,i+1:N))
  end do u_sub

  B(order(:,2)) = B
  B = B * scale_factor(:,2)

end subroutine lusbs
